USE [versaSRSv7_New]
GO
/****** Object:  StoredProcedure [dbo].[sp_Get_Custom_Actions_By_Page]    Script Date: 3/02/2021 3:11:44 PM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
ALTER PROCEDURE [dbo].[sp_Get_Custom_Actions_By_Page]
@ReqUserEmail nvarchar(100),
@ReqQueueID int, 
@ReqGroupID int,
@ReqUserID int,
@ReqStatusIDs varchar(50),
@SortBy int,
@SortOrder int,
@CurrentPage int,
@PageSize int,
@TotalRecords int output
AS

-- Create A Temporary Table To Hold The Current Page Of Data --
DECLARE @str1 as nvarchar(MAX)
DECLARE @SortIndex As nvarchar(255)

SET @str1 = 'SELECT 
(CASE WHEN tbl_Actions.RecordTypeID = 1 THEN tbl_Calls.Subject WHEN tbl_Actions.RecordTypeID = 4 THEN tbl_Problems.Subject WHEN tbl_Actions.RecordTypeID = 8 THEN tbl_ChangeRequests.Subject END) As RecordSubject, 
(CASE WHEN tbl_Actions.RecordTypeID = 1 THEN tbl_Calls.FirstName WHEN tbl_Actions.RecordTypeID = 4 THEN tbl_Problems.FirstName WHEN tbl_Actions.RecordTypeID = 8 THEN tbl_ChangeRequests.FirstName END) As CFN, 
(CASE WHEN tbl_Actions.RecordTypeID = 1 THEN tbl_Calls.LastName WHEN tbl_Actions.RecordTypeID = 4 THEN tbl_Problems.LastName WHEN tbl_Actions.RecordTypeID = 8 THEN tbl_ChangeRequests.LastName END) As CLN, 
(CASE WHEN tbl_Actions.RecordTypeID = 1 THEN tbl_Calls.DueDate WHEN tbl_Actions.RecordTypeID = 4 THEN tbl_Problems.DueDate WHEN tbl_Actions.RecordTypeID = 8 THEN tbl_ChangeRequests.DueDate END) As RecordDueDate, 
(CASE WHEN tbl_Actions.RecordTypeID = 1 THEN tbl_CallStatus.CallStatusTitle WHEN tbl_Actions.RecordTypeID = 4 THEN tbl_ProblemStatus.ProblemStatusTitle WHEN tbl_Actions.RecordTypeID = 8 THEN tbl_ChangeRequestStatus.ChangeRequestStatusTitle END) As RecordStatus, 
(CASE 
WHEN tbl_Actions.RecordTypeID = 1 THEN 
(SELECT tbl_Users.FirstName FROM tbl_Users WHERE tbl_Users.UserID = tbl_Calls.UserID)
WHEN tbl_Actions.RecordTypeID = 4 THEN 
(SELECT tbl_Users.FirstName FROM tbl_Users WHERE tbl_Users.UserID = tbl_Problems.UserID)
WHEN tbl_Actions.RecordTypeID = 8 THEN 
(SELECT tbl_Users.FirstName FROM tbl_Users WHERE tbl_Users.UserID = tbl_ChangeRequests.UserID) END) As OFN, 
(CASE 
WHEN tbl_Actions.RecordTypeID = 1 THEN 
(SELECT tbl_Users.LastName FROM tbl_Users WHERE tbl_Users.UserID = tbl_Calls.UserID)
WHEN tbl_Actions.RecordTypeID = 4 THEN 
(SELECT tbl_Users.LastName FROM tbl_Users WHERE tbl_Users.UserID = tbl_Problems.UserID)
WHEN tbl_Actions.RecordTypeID = 8 THEN 
(SELECT tbl_Users.LastName FROM tbl_Users WHERE tbl_Users.UserID = tbl_ChangeRequests.UserID) END) As OLN, 
(CASE 
WHEN tbl_Actions.RecordTypeID = 1 THEN 
(SELECT tbl_Queues.QueueName FROM tbl_Queues WHERE tbl_Queues.QueueID = tbl_Calls.QueueID)
WHEN tbl_Actions.RecordTypeID = 4 THEN 
(SELECT tbl_Queues.QueueName FROM tbl_Queues WHERE tbl_Queues.QueueID = tbl_Problems.QueueID)
WHEN tbl_Actions.RecordTypeID = 8 THEN 
(SELECT tbl_Queues.QueueName FROM tbl_Queues WHERE tbl_Queues.QueueID = tbl_ChangeRequests.QueueID) END) As QueueName, 
(CASE 
WHEN tbl_Actions.RecordTypeID = 1 THEN 
(SELECT tbl_Groups.GroupName FROM tbl_Groups WHERE tbl_Groups.GroupID = tbl_Calls.GroupID)
WHEN tbl_Actions.RecordTypeID = 4 THEN 
(SELECT tbl_Groups.GroupName FROM tbl_Groups WHERE tbl_Groups.GroupID = tbl_Problems.GroupID)
WHEN tbl_Actions.RecordTypeID = 8 THEN 
(SELECT tbl_Groups.GroupName FROM tbl_Groups WHERE tbl_Groups.GroupID = tbl_ChangeRequests.GroupID) END) As GroupName, 
(CASE 
WHEN tbl_Actions.RecordTypeID = 1 THEN 
(SELECT tbl_PrimaryKeys.PrimaryKey FROM tbl_PrimaryKeys WHERE tbl_PrimaryKeys.PrimaryKeyID = tbl_Calls.Key1)
WHEN tbl_Actions.RecordTypeID = 4 THEN 
(SELECT tbl_PrimaryKeys.PrimaryKey FROM tbl_PrimaryKeys WHERE tbl_PrimaryKeys.PrimaryKeyID = tbl_Problems.Key1)
WHEN tbl_Actions.RecordTypeID = 8 THEN 
(SELECT tbl_PrimaryKeys.PrimaryKey FROM tbl_PrimaryKeys WHERE tbl_PrimaryKeys.PrimaryKeyID = tbl_ChangeRequests.Key1) END) As PrimaryKey, 
(CASE 
WHEN tbl_Actions.RecordTypeID = 1 THEN 
(SELECT tbl_SecondaryKeys.SecondaryKey FROM tbl_SecondaryKeys WHERE tbl_SecondaryKeys.SecondaryKeyID = tbl_Calls.Key2)
WHEN tbl_Actions.RecordTypeID = 4 THEN 
(SELECT tbl_SecondaryKeys.SecondaryKey FROM tbl_SecondaryKeys WHERE tbl_SecondaryKeys.SecondaryKeyID = tbl_Problems.Key2)
WHEN tbl_Actions.RecordTypeID = 8 THEN 
(SELECT tbl_SecondaryKeys.SecondaryKey FROM tbl_SecondaryKeys WHERE tbl_SecondaryKeys.SecondaryKeyID = tbl_ChangeRequests.Key2) END) As SecondaryKey, 
(CASE 
WHEN tbl_Actions.RecordTypeID = 1 THEN 
(SELECT tbl_TertiaryKeys.TertiaryKey FROM tbl_TertiaryKeys WHERE tbl_TertiaryKeys.TertiaryKeyID = tbl_Calls.Key3)
WHEN tbl_Actions.RecordTypeID = 4 THEN 
(SELECT tbl_TertiaryKeys.TertiaryKey FROM tbl_TertiaryKeys WHERE tbl_TertiaryKeys.TertiaryKeyID = tbl_Problems.Key3)
WHEN tbl_Actions.RecordTypeID = 8 THEN 
(SELECT tbl_TertiaryKeys.TertiaryKey FROM tbl_TertiaryKeys WHERE tbl_TertiaryKeys.TertiaryKeyID = tbl_ChangeRequests.Key3) END) As TertiaryKey, 
tbl_Actions.TaskID, tbl_Actions.RecordID, tbl_Actions.RecordTypeID, tbl_Actions.DateEntered, tbl_Actions.DueDate, tbl_Actions.ActionTitle, tbl_Actions.ActionDescription, tbl_ActionStatus.ActionStatus,
tbl_Actions.PercentComplete, tbl_ActionRisk.Risk, tbl_ActionWorkflows.WorkflowOrder, 
(CASE WHEN tbl_Actions.DistributionGroupID > 0 THEN
(SELECT DistributionGroup
FROM tbl_VCRMDistributionGroups
WHERE DistributionGroupID = tbl_Actions.DistributionGroupID) 
ELSE tbl_Actions.AssignedToFirstName END) AS ATFN,
(CASE WHEN tbl_Actions.DistributionGroupID > 0 THEN ' + char(39) + char(39) + '  
ELSE tbl_Actions.AssignedToLastName END) AS ATLN,
0 AS NumAtt, 0 AS NumEmails, 
(CASE WHEN tbl_Actions.RecordTypeID = 1 THEN tbl_Calls.QueueID WHEN tbl_Actions.RecordTypeID = 4 THEN tbl_Problems.QueueID WHEN tbl_Actions.RecordTypeID = 8 THEN tbl_ChangeRequests.QueueID END) As QueueID 
FROM tbl_Actions WITH (NOLOCK) 
LEFT OUTER JOIN tbl_Calls WITH (NOLOCK) ON (tbl_Actions.RecordID = tbl_Calls.CallID AND tbl_Actions.RecordTypeID = 1)
LEFT OUTER JOIN tbl_Problems WITH (NOLOCK) ON (tbl_Actions.RecordID = tbl_Problems.ProblemID AND tbl_Actions.RecordTypeID = 4)
LEFT OUTER JOIN tbl_ChangeRequests WITH (NOLOCK) ON (tbl_Actions.RecordID = tbl_ChangeRequests.ChangeRequestID AND tbl_Actions.RecordTypeID = 8)
LEFT OUTER JOIN tbl_CallStatus WITH (NOLOCK) ON (tbl_CallStatus.CallStatusID = tbl_Calls.CallStatusID AND tbl_Actions.RecordID = tbl_Calls.CallID AND tbl_Actions.RecordTypeID = 1)
LEFT OUTER JOIN tbl_ProblemStatus WITH (NOLOCK) ON (tbl_ProblemStatus.ProblemStatusID = tbl_Problems.ProblemStatusID AND tbl_Actions.RecordID = tbl_Problems.ProblemID AND tbl_Actions.RecordTypeID = 4)
LEFT OUTER JOIN tbl_ChangeRequestStatus WITH (NOLOCK) ON (tbl_ChangeRequestStatus.ChangeRequestStatusID = tbl_ChangeRequests.ChangeRequestStatusID AND tbl_Actions.RecordID = tbl_ChangeRequests.ChangeRequestID AND tbl_Actions.RecordTypeID = 8)
LEFT OUTER JOIN tbl_ActionRisk WITH (NOLOCK) ON tbl_Actions.RiskID = tbl_ActionRisk.RiskID 
LEFT OUTER JOIN tbl_ActionStatus WITH (NOLOCK) ON tbl_Actions.ActionStatusID = tbl_ActionStatus.ActionStatusID 
LEFT OUTER JOIN tbl_ActionWorkflows WITH (NOLOCK) ON tbl_Actions.TaskID = tbl_ActionWorkflows.TaskID ' 

IF @ReqQueueID > 0
BEGIN
SET @str1 = @str1 + ' WHERE (tbl_Calls.QueueID = ' + CAST(@ReqQueueID As varchar) + ' OR tbl_Problems.QueueID = ' + CAST(@ReqQueueID As varchar) + ' OR tbl_ChangeRequests.QueueID = ' + CAST(@ReqQueueID As varchar) + ')' 

IF @ReqGroupID > 0
BEGIN
SET @str1 = @str1 + ' AND (tbl_Calls.GroupID = ' + CAST(@ReqGroupID As varchar) + ' OR tbl_Problems.GroupID = ' + CAST(@ReqGroupID As varchar) + ' OR tbl_ChangeRequests.GroupID = ' + CAST(@ReqGroupID As varchar) + ')' 
END

IF @ReqUserID > 0
BEGIN
SELECT @ReqUserEmail = (SELECT Email FROM tbl_Users WHERE UserID = @ReqUserID)
IF NOT @ReqUserEmail IS NULL
BEGIN
SET @str1 = @str1 + ' AND (tbl_Actions.AssignedToEmail = ' + char(39) + @ReqUserEmail + char(39) 
-- Add Support For Assigned To Distribution Group
SET @str1 = @str1 + ' OR (dbo.tbl_Actions.DistributionGroupID IN (
SELECT DISTINCT tbl_VCRMDistributionGroupMembers.DistributionGroupID
FROM dbo.tbl_VCRMAddresses WITH (NOLOCK) RIGHT OUTER JOIN
dbo.tbl_VCRMContact ON dbo.tbl_VCRMAddresses.ParentID = dbo.tbl_VCRMContact.ContactID RIGHT OUTER JOIN
dbo.tbl_VCRMDistributionGroupMembers WITH (NOLOCK) ON dbo.tbl_VCRMContact.ContactID = dbo.tbl_VCRMDistributionGroupMembers.ContactID
WHERE (dbo.tbl_VCRMAddresses.ParentTypeID = 2) AND 
(dbo.tbl_VCRMAddresses.AddressNumber = 1) AND (dbo.tbl_VCRMAddresses.EmailAddress1 = ' + char(39) + @ReqUserEmail + char(39) + ')
)))'
END
-- SET @str1 = @str1 + ' AND (tbl_Calls.UserID = ' + CAST(@ReqUserID As varchar) + ' OR tbl_Problems.UserID = ' + CAST(@ReqUserID As varchar) + ' OR tbl_ChangeRequests.UserID = ' + CAST(@ReqUserID As varchar) + ')' 
END
END
ELSE
BEGIN

IF @ReqUserID > 0
BEGIN
SELECT @ReqUserEmail = (SELECT Email FROM tbl_Users WHERE UserID = @ReqUserID)
END

IF NOT @ReqUserEmail IS NULL
BEGIN
SET @str1 = @str1 + ' WHERE (tbl_Actions.AssignedToEmail = ' + char(39) + @ReqUserEmail + char(39) 
-- Add Support For Assigned To Distribution Group
SET @str1 = @str1 + ' OR (dbo.tbl_Actions.DistributionGroupID IN (
SELECT DISTINCT tbl_VCRMDistributionGroupMembers.DistributionGroupID
FROM dbo.tbl_VCRMAddresses WITH (NOLOCK) RIGHT OUTER JOIN
dbo.tbl_VCRMContact ON dbo.tbl_VCRMAddresses.ParentID = dbo.tbl_VCRMContact.ContactID RIGHT OUTER JOIN
dbo.tbl_VCRMDistributionGroupMembers WITH (NOLOCK) ON dbo.tbl_VCRMContact.ContactID = dbo.tbl_VCRMDistributionGroupMembers.ContactID
WHERE (dbo.tbl_VCRMAddresses.ParentTypeID = 2) AND 
(dbo.tbl_VCRMAddresses.AddressNumber = 1) AND (dbo.tbl_VCRMAddresses.EmailAddress1 = ' + char(39) + @ReqUserEmail + char(39) + ')
)))'
END
ELSE
BEGIN
-- Ensure only return records for active queues (ie. QueueStatus = 1)
SET @str1 = @str1 + ' WHERE (tbl_Calls.QueueID IN (SELECT DISTINCT tbl_QueueUsers.QueueID FROM tbl_QueueUsers INNER JOIN tbl_Queues ON (tbl_Queues.QueueID = tbl_QueueUsers.QueueID AND tbl_Queues.QueueStatus = 1) WHERE (tbl_QueueUsers.UserID = ' + CAST(@ReqUserID AS varchar) + '))
OR tbl_Problems.QueueID IN (SELECT DISTINCT tbl_QueueUsers.QueueID FROM tbl_QueueUsers INNER JOIN tbl_Queues ON (tbl_Queues.QueueID = tbl_QueueUsers.QueueID AND tbl_Queues.QueueStatus = 1) WHERE (tbl_QueueUsers.UserID = ' + CAST(@ReqUserID AS varchar) + '))
OR tbl_ChangeRequests.QueueID IN (SELECT DISTINCT tbl_QueueUsers.QueueID FROM tbl_QueueUsers INNER JOIN tbl_Queues ON (tbl_Queues.QueueID = tbl_QueueUsers.QueueID AND tbl_Queues.QueueStatus = 1) WHERE (tbl_QueueUsers.UserID = ' + CAST(@ReqUserID AS varchar) + ')))'
END
END

IF @ReqStatusIDs = '100' -- Current Tasks
BEGIN
SET @str1 = @str1 + ' AND (tbl_Actions.ActionStatusID IN (2, 3, 4, 5, 6, 11))'

-- Unassigned Tasks
IF @ReqUserID = 0
BEGIN
SET @str1 = @str1 + ' OR (tbl_Actions.AssignedToEmail = '''') OR (tbl_Actions.DistributionGroupID = 0)'
END

END
ELSE
IF @ReqStatusIDs = '101' -- Unread Emails
BEGIN
SET @str1 = @str1 + ' AND (tbl_Actions.TaskID IN (SELECT TaskID FROM tbl_ActionAudit WHERE ActionID IN (19, 32, 76, 266, 269) AND IsUnread = 1))'
END
ELSE
IF @ReqStatusIDs = '200' -- Current Overdue
BEGIN
SET @str1 = @str1 + ' AND (tbl_Actions.ActionStatusID IN (2, 3, 4, 5, 6, 11)) AND (DATEDIFF(ss, dbo.tbl_Actions.DueDate, GETDATE()) > 0)'
END
ELSE
IF @ReqStatusIDs = '201' -- Current Due Today
BEGIN
SET @str1 = @str1 + ' AND (tbl_Actions.ActionStatusID IN (2, 3, 4, 5, 6, 11)) AND (DATEDIFF(dd, dbo.tbl_Actions.DueDate, GETDATE()) = 0) AND (DATEDIFF(MM, dbo.tbl_Actions.DueDate, GETDATE()) = 0) AND (DATEDIFF(yy, dbo.tbl_Actions.DueDate, GETDATE()) = 0)'
END
ELSE
BEGIN
IF CHARINDEX('100', @ReqStatusIDs, 0) > 0
BEGIN
-- Support for other status + current
SET @str1 = @str1 + ' AND tbl_Actions.ActionStatusID IN (' + CAST(@ReqStatusIDs AS varchar(50)) + ', 2, 3, 4, 5, 6, 11)'
END
ELSE
BEGIN
SET @str1 = @str1 + ' AND tbl_Actions.ActionStatusID IN (' + CAST(@ReqStatusIDs AS varchar(50)) + ')'
END

END

SET @str1 = @str1 + ' ORDER BY '
SET @SortIndex = 'TaskID'

IF @SortBy = 0
BEGIN
SET @str1 = @str1 + 'TaskID'
END
IF @SortBy = 1
BEGIN
SET @str1 = @str1 + 'TaskID'
END
IF @SortBy = 2
BEGIN
SET @str1 = @str1 + 'ActionTitle'
SET @SortIndex = 'ActionTitle'
END
IF @SortBy = 3
BEGIN
SET @str1 = @str1 + 'tbl_ActionStatus.ActionStatus'
SET @SortIndex = 'ActionStatus'
END
IF @SortBy = 4
BEGIN
SET @str1 = @str1 + 'tbl_Actions.DueDate'
SET @SortIndex = 'ActionDueDate'
END
IF @SortBy = 5
BEGIN
SET @str1 = @str1 + 'PercentComplete'
SET @SortIndex = 'ActionPercentComplete'
END
IF @SortBy = 6
BEGIN
SET @str1 = @str1 + 'tbl_ActionRisk.Risk'
SET @SortIndex = 'ActionRisk'
END
IF @SortBy = 7
BEGIN
SET @str1 = @str1 + 'AssignedToFirstName + '' '' + AssignedToLastName'
SET @SortIndex = 'ATFN, ATLN'
END
IF @SortBy = 8
BEGIN
SET @str1 = @str1 + 'tbl_Actions.DateEntered'
SET @SortIndex = 'ActionDateEntered'
END
IF @SortBy = 9
BEGIN
SET @str1 = @str1 + 'RecordSubject'
SET @SortIndex = 'RecordSubject'
END
IF @SortBy = 10
BEGIN
	SET @str1 = @str1 + 'CFN'
	SET @SortIndex = 'CFN, CLN'
END
IF @SortBy = 11
BEGIN
SET @str1 = @str1 + 'RecordStatus'
SET @SortIndex = 'RecordStatus'
END
IF @SortBy = 12
BEGIN
SET @str1 = @str1 + 'RecordDueDate'
SET @SortIndex = 'RecordDueDate'
END
IF @SortBy = 13
BEGIN
SET @str1 = @str1 + 'QueueName'
SET @SortIndex = 'QueueName'
END
IF @SortBy = 14
BEGIN
SET @str1 = @str1 + 'GroupName'
SET @SortIndex = 'GroupName'
END
IF @SortBy = 15
BEGIN
	SET @str1 = @str1 + 'OFN'
	SET @SortIndex = 'OFN, OLN'
END
IF @SortBy = 16
BEGIN
SET @str1 = @str1 + 'PrimaryKey'
SET @SortIndex = 'PrimaryKey'
END
IF @SortBy = 17
BEGIN
SET @str1 = @str1 + 'SecondaryKey'
SET @SortIndex = 'SecondaryKey'
END
IF @SortBy = 18
BEGIN
SET @str1 = @str1 + 'TertiaryKey'
SET @SortIndex = 'TertiaryKey'
END
IF @SortOrder = 0
BEGIN
SET @str1 = @str1 + ' DESC'
END
IF @SortOrder = 1
BEGIN
SET @str1 = @str1 + ' ASC'
END

CREATE TABLE #TempTable
(
ID int IDENTITY,
[Timestamp] timestamp, 
RecordSubject nvarchar(500), 
CFN nvarchar(255), 
CLN nvarchar(255), 
RecordDueDate datetime, 
RecordStatus nvarchar(100), 
OFN nvarchar(255),
OLN nvarchar(255),
QueueName nvarchar(255),
GroupName nvarchar(255),
PrimaryKey nvarchar(255),
SecondaryKey nvarchar(255),
TertiaryKey nvarchar(255),
TaskID int,
RecordID int,
RecordTypeID int,
ActionDateEntered datetime,
ActionDueDate datetime,
ActionTitle nvarchar(500),
ActionDescription nvarchar(max),
ActionStatus nvarchar(100),
ActionPercentComplete int,
ActionRisk nvarchar(100),
WorkflowOrder int, 
ATFN nvarchar(255),
ATLN nvarchar(255),
NumAtt int,
NumEmails int,
QueueID int,
PRIMARY KEY ([ID], [Timestamp])
)

-- Create Index for TempTable with Unique Index Name
DECLARE @strIndexQuery nvarchar(1000)
SET @strIndexQuery = 'CREATE INDEX IX_TempTable_' + REPLACE(CAST(NEWID() As varchar(50)), '-', '_') + ' ON tempdb..#TempTable (' + @SortIndex + ')'
EXEC(@strIndexQuery)

-- Fill The Temporary Table With Appropriate Data --
INSERT INTO #TempTable
(
RecordSubject, 
CFN,
CLN, 
RecordDueDate, 
RecordStatus, 
OFN,
OLN,
QueueName,
GroupName,
PrimaryKey,
SecondaryKey, 
TertiaryKey, 
TaskID,
RecordID,
RecordTypeID,
ActionDateEntered,
ActionDueDate,
ActionTitle,
ActionDescription,
ActionStatus,
ActionPercentComplete,
ActionRisk,
WorkflowOrder, 
ATFN,
ATLN,
NumAtt,
NumEmails,
QueueID
)
EXEC(@str1)

-- Create A Variable To Identify The First And Last Record That Should Be Selected --
DECLARE @FirstRec int, @LastRec int
SELECT @FirstRec = (@CurrentPage - 1) * @PageSize
SELECT @LastRec = (@CurrentPage * @PageSize + 1)
-- Select One Page Of Data Based On The Record Numbers Above --
SELECT
RecordSubject, 
CFN,
CLN, 
RecordDueDate, 
RecordStatus, 
OFN,
OLN,
QueueName,
GroupName,
PrimaryKey,
SecondaryKey, 
TertiaryKey, 
TaskID,
RecordID,
RecordTypeID,
ActionDateEntered,
ActionDueDate,
ActionTitle,
ActionDescription,
ActionStatus,
ActionPercentComplete,
ActionRisk,
WorkflowOrder, 
ATFN,
ATLN,
(select Count(ActionCount) from tbl_ActionAuditAttach WITH (NOLOCK) Where TaskID = #TempTable.TaskID) As NumAtt,
(select Count(ActionCount) from tbl_ActionAudit WITH (NOLOCK) Where tbl_ActionAudit.TaskID= #TempTable.TaskID And ActionID IN (19, 32, 76, 266, 269) And IsUnRead = 1)  As NumEmails,
QueueID
FROM #TempTable
WHERE
ID > @FirstRec
AND
ID < @LastRec 
ORDER BY ID ASC

-- Return The Total Number Of Records Available As An Output Parameter --
SELECT @TotalRecords = COUNT(*) FROM #TempTable